from .py_unconscious import *
import asyncio
import threading
import asyncio

__doc__ = py_unconscious.__doc__
if hasattr(py_unconscious, "__all__"):
    __all__ = py_unconscious.__all__


class Client:
    def __init__(self):
        self.loop = asyncio.new_event_loop()
        self.thread = threading.Thread(target=self.run_server)
        self.thread.start()

    def run_server(self):
        asyncio.set_event_loop(self.loop)
        self.loop.run_until_complete(self.main())

    async def main(self):
        await py_unconscious.rust_server()

    def stop(self):
        self.loop.call_soon_threadsafe(self.loop.stop)
        self.thread.join()


def 役人(cls=None, default_name=None, thread=None):
    def get_default_thread():
        return getattr(役人, "default_thread", "main")

    if thread is None:
        thread = get_default_thread()

    def decorator(cls):
        class WrappedNpc(cls):
            def __init__(self, name=default_name, thread=thread):
                name = name or cls.__name__
                super().__init__(name=name, thread=thread, message_types=[])
                if hasattr(cls, "on_message"):
                    self._set_on_message(
                        lambda message, client_id: cls.on_message(
                            self, message, client_id
                        )
                    )

            def __call__(self):
                self.awaken()
                if hasattr(cls, "on_alive"):
                    self.on_alive()

        return WrappedNpc

    if cls is not None:
        # If @npc is used without parentheses
        return decorator(cls)
    return decorator


# def set_default_thread(thread_name):
#     setattr(役人, "default_thread", thread_name)


# ツ.set_default_thread = set_default_thread
